Index: callerid.c
===================================================================
RCS file: /usr/cvsroot/asterisk/callerid.c,v
retrieving revision 1.5
diff -u -r1.5 callerid.c
--- callerid.c	1 Sep 2003 15:59:57 -0000	1.5
+++ callerid.c	8 Oct 2003 15:50:59 -0000
@@ -110,8 +110,8 @@
 {
 	struct callerid_state *cid;
 	cid = malloc(sizeof(struct callerid_state));
-	memset(cid, 0, sizeof(struct callerid_state));
 	if (cid) {
+		memset(cid, 0, sizeof(struct callerid_state));
 		cid->fskd.spb = 7;		/* 1200 baud */
 		cid->fskd.hdlc = 0;		/* Async */
 		cid->fskd.nbit = 8;		/* 8 bits */
Index: channels/chan_zap.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_zap.c,v
retrieving revision 1.109
diff -u -r1.109 chan_zap.c
--- channels/chan_zap.c	6 Oct 2003 05:09:42 -0000	1.109
+++ channels/chan_zap.c	8 Oct 2003 15:51:06 -0000
@@ -4359,6 +4359,8 @@
 			} else
 				ast_log(LOG_WARNING, "Unable to get caller ID space\n");
 		}
+		else
+			cs = NULL;
 		if (name && number) {
 			snprintf(cid, sizeof(cid), "\"%s\" <%s>", name, number);
 		} else if (name) {
@@ -4368,6 +4370,8 @@
 		} else {
 			strcpy(cid, "");
 		}
+		if (cs)
+			callerid_free(cs);
 		if (strlen(cid)) {
 			chan->callerid = strdup(cid);
 			chan->ani = strdup(cid);
